<?php
defined('_JEXEC') or die(':)');
jimport('joomla.form.formfield');

class JFormFieldYandexmap extends JFormField
{
    protected $apiscript = 'https://api-maps.yandex.ru/2.1/?lang=ru_RU';
    function FirstStart()
    {
        $doc = JFactory::getDocument();
        $doc->addScript($this->apiscript);
        $module_id = 0;
        $typeSelector = "'typeSelector', ";
        $no_apiKey = JText::_('mod_maps2022_DOESNT_WORK_WITHOUT_AN_AP_KEY');
        $wi_ = JText::_('mod_maps2022_WIDTH_PHP');
        $he_ = JText::_('mod_maps2022_HEIGHT_PHP');
        $centermap = JText::_('mod_maps2022_CENTERMAP_PHP');
        $scope =  JText::_('mod_maps2022_SCOPE_PHP');
        $adress =  JText::_('mod_maps2022_ADRESS');
        $soordinates =  JText::_('mod_maps2022_COORDINATES');
        $color = "'green'";
        $searchControl = " // Создаем экземпляр класса ymaps.control.SearchControl
                    mySearchControl = new ymaps.control.SearchControl({
                            options: {
                                noPlacemark: true
                            }
                        }),
                     mySearchResults = new ymaps.GeoObjectCollection({}, {
                                   preset: 'islands#grayClusterIcons'
                        });                    
                    myMap.controls.add(mySearchControl);
                    myMap.geoObjects.add(mySearchResults);
                    mySearchResults.events.add('click', function (e) {
                        var coords = e.get('coords');
                        document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                        document.getElementById('ypoint').style.borderColor = $color;
                        copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                        CoordLoad();
                   
                          ymaps.geocode(coords).then(function(res) { 
                            var data = res.geoObjects.get(0).properties.getAll();
                            document.getElementById('address').value = data.text; 
                            document.getElementById('address').style.borderColor = $color;
                        });
          
                    });
                       // Выбранный результат помещаем в коллекцию.
                        mySearchControl.events.add('resultselect', function (e) {
                        var index = e.get('index');                   
                        mySearchControl.getResult(index).then(function (res) {
                        mySearchResults.add(res);         
                        });
                    }).add('submit', function () { mySearchResults.removeAll(); })
                ";
        $m = "<div id=\"map$module_id\" style=\"width:$wi_; height:$he_ ; padding-bottom: 20px\"></div>            
            $soordinates:
            <input type=\"text\" id=\"ypoint\" class=\"form - input\"> 
            
            $adress:
            <input placeholder=\"$no_apiKey\" type=\"text\" id=\"address\">             
            
            <span id='coord_load'></span>";

        $m .= "<script>
            var myMap;
            ymaps.ready(init);
            function init () {
                var myMap = new ymaps.Map(\"map$module_id\", {
                    center: [$centermap],
                    zoom: $scope,
                    controls: ['zoomControl',  $typeSelector 'fullscreenControl']   });               
                    $searchControl
                  

                var myPlacemark = new ymaps.Placemark([$centermap], null, {                 
                    preset: 'islands#blueDotIcon',
                    draggable: true
                });
                
                     // Слушаем клик на карте.
                    myMap.events.add('click', function (e) {
                    var coords = e.get('coords');
                        /* coords  -  массив координат */       
                        document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                        document.getElementById('ypoint').style.borderColor = $color;
                        copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                        CoordLoad();


                    // Если метка уже создана – просто передвигаем ее.
                    if (myPlacemark) {
                        myPlacemark.geometry.setCoordinates(coords);
                    }
                    // Если нет – создаем.
                    else {
                        myPlacemark = createPlacemark(coords);
                        myMap.geoObjects.add(myPlacemark);
                        // Слушаем событие окончания перетаскивания на метке.
                        myPlacemark.events.add('dragend', function (e) {
                            getAddress(myPlacemark.geometry.getCoordinates());
                        });
                    }
                    getAddress(coords);
                });
     
                
                
                // Создание метки.
                function createPlacemark(coords) {                                         

                    return new ymaps.Placemark(coords, {
                        iconCaption: 'поиск...'
                    }, {
                        preset: 'islands#blueDotIcon',
                        draggable: true
                    });
                }
            
                // Определяем адрес по координатам (обратное геокодирование).
                function getAddress(coords) {
                    myPlacemark.properties.set('iconCaption', 'поиск...');
                    ymaps.geocode(coords).then(function (res) {
                        var firstGeoObject = res.geoObjects.get(0);
            
                        myPlacemark.properties
                            .set({
                                // Формируем строку с данными об объекте.
                                iconCaption: [
                                    // Название населенного пункта или вышестоящее административно-территориальное образование.
                                    firstGeoObject.getLocalities().length ? firstGeoObject.getLocalities() : firstGeoObject.getAdministrativeAreas(),
                                    // Получаем путь до топонима, если метод вернул null, запрашиваем наименование здания.
                                    firstGeoObject.getThoroughfare() || firstGeoObject.getPremise()
                                ].filter(Boolean).join(', '),
                                // В качестве контента балуна задаем строку с адресом объекта.
                                balloonContent: firstGeoObject.getAddressLine()
                            });
             
                        
                    var data = res.geoObjects.get(0).properties.getAll();
                    document.getElementById('address').value = data.text;  
                    document.getElementById('address').style.borderColor = $color;

                    });
                }           
                    /* Событие dragend перетаскивание мышью - получение нового адреса */
                    myPlacemark.events.add('dragend', function(e){
                    var coords = e.get('target').geometry.getCoordinates();
                    /* cord  -  массив координат */       
                    document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                    document.getElementById('ypoint').style.borderColor = $color;
                    copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                    CoordLoad();
                    //Координаты скопированы
                    ymaps.geocode(coords).then(function(res) {
                    getAddress(coords);

                    });

                });
                    function copyToClipboard(text){
                       var dummy = document.createElement(\"textarea\");
                        document.body.appendChild(dummy);
                        dummy.value = text;
                        dummy.select();
                        document.execCommand(\"copy\");
                        document.body.removeChild(dummy);
                    }
                    function CoordLoad(){
                        document.getElementById('coord_load').style.display = 'inline';
                        document.getElementById('coord_load').textContent  = 'КООРДИНАТЫ СКОПИРОВАНЫ'; 
                        document.getElementById('coord_load').style.color='red'; 
                        document.getElementById('coord_load').style.fontSize = '16px'; 
                        setTimeout(function(){document.getElementById('coord_load').style.display = 'none';}, 2000);
                    } 
                    
                myMap.geoObjects.add(myPlacemark);   
             }
                
		</script>";
        return $m;
    }
    function ModuleId(){
        return intval(@$_REQUEST['id']);
    }
    function SelectModule(){
        if($this->ModuleId()) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*')
                ->from($db->quoteName('#__modules'))
                ->where($db->quoteName('id') . ' = ' . $this->ModuleId());
            $db->setQuery($query);
            return $db->loadObjectList();
        }
        return false;
    }
    protected function getInput()
	{

    	if($this->SelectModule()) {

            $rows = $this->SelectModule();
            foreach ($rows as $k => $row) {
                $items = array();
                $params = json_decode($row->params);
                if ($params->apikey) $script = 'https://api-maps.yandex.ru/2.1/?apikey=' . $params->apikey . '&lang=ru_RU'; else $script =  $this->apiscript;
                if (!$params->apikey) $Key_ok = JText::_('mod_maps2022_DOESNT_WORK_WITHOUT_AN_AP_KEY');
                if ($params->centermap) $centermap = $params->centermap; else $centermap = JText::_('mod_maps2022_CENTERMAP_PHP');
                if ($params->scope) $scope = $params->scope; else $scope =  JText::_('mod_maps2022_SCOPE_PHP');
                if ($params->bottom_bool) $searchControl = true; else $searchControl = false;
                if ($params->typemap_bool) $typeSelector = "'typeSelector', "; else $typeSelector = '';
                if ($params->trafficControl) $trafficControl = 'true'; else $trafficControl = 'false';

                if ($params->wi) $wi = trim($params->wi); else $wi = JText::_('mod_maps2022_WIDTH_PHP');
                if ($params->he) $he = trim($params->he); else $he = JText::_('mod_maps2022_HEIGHT_PHP');
                if ((strpos($wi, '%') === false) and (strpos($wi, 'px') === false)) $wi = $wi . "px";
                if ((strpos($he, 'px') === false)) $he = $he . "px";
                $he = str_replace('%','',$he);

                if ($params->iconmap) $iconmap = $params->iconmap;
                if ($params->icon_wi) $icon_wi = $params->icon_wi;
                if ($params->icon_he) $icon_he = $params->icon_he;
                if ($params->zn1) $zn1 = $params->zn1;
                if ($params->zn2) $zn2 = $params->zn2;
                if ($params->items) {
                    foreach ($params->items as $item) {
                        if ($item->spb_point) $spb_point[] = $item->spb_point; else $spb_point[] = $iconmap;
                        $spb_coordinates[] = $item->spb_coordinates;
                        $spb_description[] = $item->spb_description;
                        $spb_class[] = $item->spb_class;
                    }
                }


            } // foreach

            $doc = JFactory::getDocument();
            $doc->addScript($script);
            $myPlacemark = array();
            $addmyPlacemark = array();
            foreach ($spb_point as $k => $Placemark) {
                $myPlacemark[$k] = "myPlacemark$k = new ymaps.Placemark([$spb_coordinates[$k]], {
                    balloonContent: '$spb_description[$k]'}, {
                    iconLayout: 'default#image',
                    iconImageHref: '/$spb_point[$k]',
                    iconImageSize: [$icon_wi, $icon_he],
                    iconImageOffset: [$zn1, $zn2]
                });";
                $addmyPlacemark[$k] = ".add(myPlacemark$k)";
            }
            $implodePlacemark = implode('', $myPlacemark);
            $implodeaddPlacemark = implode('', $addmyPlacemark);
            $color = "'green'";
            $adress =  JText::_('mod_maps2022_ADRESS');
            $soordinates =  JText::_('mod_maps2022_COORDINATES');
            if($searchControl) {
                $searchControl = " // Создаем экземпляр класса ymaps.control.SearchControl
                    mySearchControl = new ymaps.control.SearchControl({
                            options: {
                                noPlacemark: true
                            }
                        }),
                     mySearchResults = new ymaps.GeoObjectCollection({}, {
                                   preset: 'islands#grayClusterIcons'
                        });                    
                    myMap.controls.add(mySearchControl);
                    myMap.geoObjects.add(mySearchResults);
                    mySearchResults.events.add('click', function (e) {
                        var coords = e.get('coords');
                        document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                        document.getElementById('ypoint').style.borderColor = $color;
                        copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                        CoordLoad();
                   
                          ymaps.geocode(coords).then(function(res) { 
                            var data = res.geoObjects.get(0).properties.getAll();
                            document.getElementById('address').value = data.text; 
                            document.getElementById('address').style.borderColor = $color;
                        });
          
                    });
                       // Выбранный результат помещаем в коллекцию.
                        mySearchControl.events.add('resultselect', function (e) {
                        var index = e.get('index');                   
                        mySearchControl.getResult(index).then(function (res) {
                        mySearchResults.add(res);         
                        });
                    }).add('submit', function () { mySearchResults.removeAll(); })
                ";
            }

            $m = '<div id="map' .$this->ModuleId(). '" style="width:'.$wi.'; height:'.$he.' ; padding-bottom: 20px"></div>';
            
            $m.= "$soordinates:
            <input type=\"text\" id=\"ypoint\" class=\"form-input\"> 
            
            $adress:
            <input placeholder=\"$Key_ok\" type=\"text\" id=\"address\">             
            
            <span id='coord_load'></span>";

            $m .= "<script>
            var myMap;
            ymaps.ready(init);
            function init () {
                var myMap = new ymaps.Map(\"map".$this->ModuleId()."\", {
                    center: [$centermap],
                    zoom: $scope,
                    controls: ['zoomControl',  $typeSelector 'fullscreenControl']   });               
                    $searchControl
                    $implodePlacemark
                    var trafficControl = new ymaps.control.TrafficControl({ state: {
                    providerKey: 'traffic#actual',
                    trafficShown: $trafficControl
                }});
                myMap.controls.add(trafficControl);
                trafficControl.getProvider('traffic#actual').state.set('infoLayerShown', true);

                var myPlacemark = new ymaps.Placemark([$centermap], null, {                 
                    preset: 'islands#blueDotIcon',
                    draggable: true
                });
                
                     // Слушаем клик на карте.
                    myMap.events.add('click', function (e) {
                    var coords = e.get('coords');
                        /* coords  -  массив координат */       
                        document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                        document.getElementById('ypoint').style.borderColor = $color;
                        copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                        CoordLoad();


                    // Если метка уже создана – просто передвигаем ее.
                    if (myPlacemark) {
                        myPlacemark.geometry.setCoordinates(coords);
                    }
                    // Если нет – создаем.
                    else {
                        myPlacemark = createPlacemark(coords);
                        myMap.geoObjects.add(myPlacemark);
                        // Слушаем событие окончания перетаскивания на метке.
                        myPlacemark.events.add('dragend', function (e) {
                            getAddress(myPlacemark.geometry.getCoordinates());
                        });
                    }
                    getAddress(coords);
                });
     
                
                
                // Создание метки.
                function createPlacemark(coords) {                                         

                    return new ymaps.Placemark(coords, {
                        iconCaption: 'поиск...'
                    }, {
                        preset: 'islands#blueDotIcon',
                        draggable: true
                    });
                }
            
                // Определяем адрес по координатам (обратное геокодирование).
                function getAddress(coords) {
                    myPlacemark.properties.set('iconCaption', 'поиск...');
                    ymaps.geocode(coords).then(function (res) {
                        var firstGeoObject = res.geoObjects.get(0);
            
                        myPlacemark.properties
                            .set({
                                // Формируем строку с данными об объекте.
                                iconCaption: [
                                    // Название населенного пункта или вышестоящее административно-территориальное образование.
                                    firstGeoObject.getLocalities().length ? firstGeoObject.getLocalities() : firstGeoObject.getAdministrativeAreas(),
                                    // Получаем путь до топонима, если метод вернул null, запрашиваем наименование здания.
                                    firstGeoObject.getThoroughfare() || firstGeoObject.getPremise()
                                ].filter(Boolean).join(', '),
                                // В качестве контента балуна задаем строку с адресом объекта.
                                balloonContent: firstGeoObject.getAddressLine()
                            });
             
                        
                    var data = res.geoObjects.get(0).properties.getAll();
                    document.getElementById('address').value = data.text;  
                    document.getElementById('address').style.borderColor = $color;

                    });
                }           
                    /* Событие dragend перетаскивание мышью - получение нового адреса */
                    myPlacemark.events.add('dragend', function(e){
                    var coords = e.get('target').geometry.getCoordinates();
                    /* cord  -  массив координат */       
                    document.getElementById('ypoint').value = coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6);
                    document.getElementById('ypoint').style.borderColor = $color;
                    copyToClipboard(coords[0].toPrecision(6)+ ', '+ coords[1].toPrecision(6));
                    CoordLoad();
                    //Координаты скопированы
                    ymaps.geocode(coords).then(function(res) {
                    getAddress(coords);

                    });

                });
                    function copyToClipboard(text){
                       var dummy = document.createElement(\"textarea\");
                        document.body.appendChild(dummy);
                        dummy.value = text;
                        dummy.select();
                        document.execCommand(\"copy\");
                        document.body.removeChild(dummy);
                    }
                    function CoordLoad(){
                        document.getElementById('coord_load').style.display = 'inline';
                        document.getElementById('coord_load').textContent  = 'КООРДИНАТЫ СКОПИРОВАНЫ'; 
                        document.getElementById('coord_load').style.color='red'; 
                        document.getElementById('coord_load').style.fontSize = '16px'; 
                        setTimeout(function(){document.getElementById('coord_load').style.display = 'none';}, 2000);
                    } 
                    
                myMap.geoObjects$implodeaddPlacemark.add(myPlacemark);   
             }
                
		</script>";

          return $m;

        } else {

          return $this->FirstStart();

        }
	}

}
